=== debian/changelog ===
yquake2 (6.00~dfsg1-1) unstable; urgency=medium

  * New upstream release
    - remove several patches, applied upstream

 -- Simon McVittie <smcv@debian.org>  Tue, 13 Dec 2016 13:34:32 +0000
