## yquake2 7.01~dfsg1

=== CMakeLists.txt ===
--- 
+++ 
@@ -31,7 +31,7 @@
 #  -Wall                -> More warnings
 #  -fno-strict-aliasing -> Quake 2 is far away from strict aliasing
 #  -fwrapv              -> Make signed integer overflows defined
-set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wall -fno-strict-aliasing -fwrapv")
+set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -std=gnu99 -Wall -fno-strict-aliasing -fwrapv")
 
 # Use -O2 as maximum optimization level. -O3 has it's problems with yquake2.
 string(REPLACE "-O3" "-O2" CMAKE_C_FLAGS_RELEASE "${CMAKE_C_FLAGS_RELEASE}")
@@ -43,9 +43,13 @@
 option(SYSTEMWIDE_SUPPORT "Enable systemwide installation of game assets" OFF)
 
 # These variables will act as our list of include folders and linker flags
-set(yquake2LinkerFlags)
 set(yquake2IncludeDirectories)
 set(yquake2LinkerDirectories)
+set(yquake2LinkerFlags)
+set(yquake2ClientLinkerFlags)
+set(yquake2RendererLinkerFlags)
+set(yquake2SDLLinkerFlags)
+set(yquake2ZLibLinkerFlags)
 
 # Set directory locations (allowing us to move directories easily)
 set(SOURCE_DIR ${CMAKE_CURRENT_LIST_DIR}/src)
@@ -54,6 +58,7 @@
 set(GAME_SRC_DIR ${SOURCE_DIR}/game)
 set(SERVER_SRC_DIR ${SOURCE_DIR}/server)
 set(CLIENT_SRC_DIR ${SOURCE_DIR}/client)
+set(GL_SRC_DIR ${SOURCE_DIR}/client/refresh)
 
 # Operating system
 set(YQ2OSTYPE "${CMAKE_SYSTEM_NAME}" CACHE STRING "Override operation system type")
@@ -78,22 +83,22 @@
 if(${SDL2_FOUND})
 	add_definitions(-DSDL2)
 	list(APPEND yquake2IncludeDirectories "${SDL2_INCLUDE_DIR}/..")
-	list(APPEND yquake2LinkerFlags ${SDL2_LIBRARY})
+	list(APPEND yquake2SDLLinkerFlags ${SDL2_LIBRARY})
 else()
 	find_package(SDL REQUIRED)
 	add_definitions(-DWITH_CDA)
 	list(APPEND yquake2IncludeDirectories "${SDL_INCLUDE_DIR}/..")
-	list(APPEND yquake2LinkerFlags ${SDL_LIBRARY})
+	list(APPEND yquake2SDLLinkerFlags ${SDL_LIBRARY})
 endif()
 
 find_package(OpenGL REQUIRED)
 list(APPEND yquake2IncludeDirectories ${OPENGL_INCLUDE_DIR})
-list(APPEND yquake2LinkerFlags ${OPENGL_LIBRARIES})
+list(APPEND yquake2RendererLinkerFlags ${OPENGL_LIBRARIES})
 
 if(${ZIP_SUPPORT})
 	find_package(ZLIB REQUIRED)
 	list(APPEND yquake2IncludeDirectories ${ZLIB_INCLUDE_DIRS})
-	list(APPEND yquake2LinkerFlags ${ZLIB_LIBRARIES})
+	list(APPEND yquake2ZLibLinkerFlags ${ZLIB_LIBRARIES})
 	add_definitions(-DZIP -DNOUNCRYPT)
 endif()
 
@@ -102,7 +107,7 @@
 	if(${OGGVORBIS_FOUND})
 		add_definitions(-DOGG)
 		list(APPEND yquake2IncludeDirectories ${OGGVORBIS_INCLUDE_DIR})
-		list(APPEND yquake2LinkerFlags ${OGG_LIBRARY} ${VORBIS_LIBRARY} ${VORBISFILE_LIBRARY})
+		list(APPEND yquake2ClientLinkerFlags ${OGG_LIBRARY} ${VORBIS_LIBRARY} ${VORBISFILE_LIBRARY})
 	endif()
 endif()
 
@@ -112,7 +117,7 @@
 	# TODO: OS X is still missing here
 	if(${OPENAL_FOUND} AND NOT(${CMAKE_SYSTEM_NAME} MATCHES "Darwin"))
 		list(APPEND yquake2IncludeDirectories "${OPENAL_INCLUDE_DIR}")
-		list(APPEND yquake2LinkerFlags ${OPENAL_LIBRARY})
+		list(APPEND yquake2ClientLinkerFlags ${OPENAL_LIBRARY})
 
 		if(${CMAKE_SYSTEM_NAME} MATCHES "Windows")
 			add_definitions(-DUSE_OPENAL -DDEFAULT_OPENAL_DRIVER="openal32.dll")
@@ -127,7 +132,7 @@
 endif()
 
 if(${CMAKE_SYSTEM_NAME} MATCHES "Windows")
-	list(APPEND yquake2LinkerFlags "-lm")
+	list(APPEND yquake2LinkerFlags "-lm -static-libgcc")
 else()
 	list(APPEND yquake2LinkerFlags "-lm -rdynamic")
 endif()
@@ -136,13 +141,12 @@
 
 # With all of those libraries and user defined paths
 # added, lets give them to the compiler and linker.
-include_directories(${yquake2IncludeDirectories})
+include_directories(${yquake2IncludeDirectories} ${CMAKE_SOURCE_DIR}/src/client/refresh/gl3/glad/include)
 link_directories(${yquake2LinkerDirectories})
 
 set(Backends-Generic-Source
 	${BACKENDS_SRC_DIR}/generic/misc.c
 	${BACKENDS_SRC_DIR}/generic/qal.c
-	${BACKENDS_SRC_DIR}/generic/qgl.c
 	${BACKENDS_SRC_DIR}/generic/vid.c
 
 	${BACKENDS_SRC_DIR}/sdl/cd.c
@@ -154,7 +158,6 @@
 set(Backends-Generic-Header
 	${BACKENDS_SRC_DIR}/generic/header/input.h
 	${BACKENDS_SRC_DIR}/generic/header/qal.h
-	${BACKENDS_SRC_DIR}/generic/header/qgl.h
 	)
 
 set(Backends-Unix-Source
@@ -183,12 +186,21 @@
 	${BACKENDS_SRC_DIR}/windows/header/winquake.h
 	)
 
+set(GL-Windows-Source
+	${BACKENDS_SRC_DIR}/windows/shared/mem.c
+	)
+
+set(GL-Unix-Source
+	${BACKENDS_SRC_DIR}/unix/shared/hunk.c
+	)
 
 # Set the nessesary platform specific source
 if(${CMAKE_SYSTEM_NAME} MATCHES "Windows")
 	set(Platform-Specific-Source ${Backends-Windows-Source} ${Backends-Windows-Header})
+	set(GL-Platform-Specific-Source ${GL-Windows-Source})
 else()
 	set(Platform-Specific-Source ${Backends-Unix-Source} ${Backends-Unix-Header})
+	set(GL-Platform-Specific-Source ${GL-Unix-Source})
 endif()
 
 set(Game-Source
@@ -293,22 +305,6 @@
 	${CLIENT_SRC_DIR}/cl_screen.c
 	${CLIENT_SRC_DIR}/cl_tempentities.c
 	${CLIENT_SRC_DIR}/cl_view.c
-	${CLIENT_SRC_DIR}/refresh/r_draw.c
-	${CLIENT_SRC_DIR}/refresh/r_image.c
-	${CLIENT_SRC_DIR}/refresh/r_light.c
-	${CLIENT_SRC_DIR}/refresh/r_lightmap.c
-	${CLIENT_SRC_DIR}/refresh/r_main.c
-	${CLIENT_SRC_DIR}/refresh/r_mesh.c
-	${CLIENT_SRC_DIR}/refresh/r_misc.c
-	${CLIENT_SRC_DIR}/refresh/r_model.c
-	${CLIENT_SRC_DIR}/refresh/r_scrap.c
-	${CLIENT_SRC_DIR}/refresh/r_surf.c
-	${CLIENT_SRC_DIR}/refresh/r_warp.c
-	${CLIENT_SRC_DIR}/refresh/files/md2.c
-	${CLIENT_SRC_DIR}/refresh/files/pcx.c
-	${CLIENT_SRC_DIR}/refresh/files/sp2.c
-	${CLIENT_SRC_DIR}/refresh/files/stb.c
-	${CLIENT_SRC_DIR}/refresh/files/wal.c
 	${CLIENT_SRC_DIR}/menu/menu.c
 	${CLIENT_SRC_DIR}/menu/qmenu.c
 	${CLIENT_SRC_DIR}/menu/videomenu.c
@@ -356,6 +352,11 @@
 	${CLIENT_SRC_DIR}/header/screen.h
 	${CLIENT_SRC_DIR}/header/vid.h
 	${CLIENT_SRC_DIR}/menu/header/qmenu.h
-	${CLIENT_SRC_DIR}/refresh/constants/anorms.h
-	${CLIENT_SRC_DIR}/refresh/constants/anormtab.h
-	${CLIENT_SRC_DIR}/refresh/constants/warpsin.h
+	${CLIENT_SRC_DIR}/sound/header/cdaudio.h
+	${CLIENT_SRC_DIR}/sound/header/local.h
+	${CLIENT_SRC_DIR}/sound/header/sound.h
+	${CLIENT_SRC_DIR}/sound/header/vorbis.h
+	${COMMON_SRC_DIR}/header/common.h
+	${COMMON_SRC_DIR}/header/crc.h
+	${COMMON_SRC_DIR}/header/files.h
+	${COMMON_SRC_DIR}/header/glob.h
