=== Makefile ===
--- 
+++ 
@@ -100,28 +100,28 @@
 
 # Detect the OS
 ifdef SystemRoot
-OSTYPE ?= Windows
-else
-OSTYPE ?= $(shell uname -s)
+YQ2_OSTYPE := Windows
+else
+YQ2_OSTYPE ?= $(shell uname -s)
 endif
 
 # Special case for MinGW
-ifneq (,$(findstring MINGW,$(OSTYPE)))
-OSTYPE := Windows
+ifneq (,$(findstring MINGW,$(YQ2_OSTYPE)))
+YQ2_OSTYPE := Windows
 endif
 
 # Detect the architecture
-ifeq ($(OSTYPE), Windows)
+ifeq ($(YQ2_OSTYPE), Windows)
 ifdef PROCESSOR_ARCHITEW6432
 # 64 bit Windows
-ARCH ?= $(PROCESSOR_ARCHITEW6432)
+YQ2_ARCH ?= $(PROCESSOR_ARCHITEW6432)
 else
 # 32 bit Windows
-ARCH ?= $(PROCESSOR_ARCHITECTURE)
-endif
-else
-# Normalize some abiguous ARCH strings
-ARCH ?= $(shell uname -m | sed -e 's/i.86/i386/' -e 's/amd64/x86_64/' -e 's/^arm.*/arm/')
+YQ2_ARCH ?= $(PROCESSOR_ARCHITECTURE)
+endif
+else
+# Normalize some abiguous YQ2_ARCH strings
+YQ2_ARCH ?= $(shell uname -m | sed -e 's/i.86/i386/' -e 's/amd64/x86_64/' -e 's/^arm.*/arm/')
 endif
 
 # Disable CDA for SDL2
@@ -135,7 +135,6 @@
 CDA_DISABLED:=yes
 endif
 endif
-
 
 # ----------
 
@@ -156,19 +155,19 @@
 #
 # -MMD to generate header dependencies. (They cannot be
 #  generated if building universal binaries on OSX)
-ifeq ($(OSTYPE), Darwin)
+ifeq ($(YQ2_OSTYPE), Darwin)
 CFLAGS := -O2 -fno-strict-aliasing -fomit-frame-pointer \
 		  -Wall -pipe -g -fwrapv
 CFLAGS += $(OSX_ARCH)
 else
-CFLAGS := -O2 -fno-strict-aliasing -fomit-frame-pointer \
+CFLAGS := -std=gnu99 -O2 -fno-strict-aliasing \
 		  -Wall -pipe -g -ggdb -MMD -fwrapv
 endif
 
 # ----------
 
 # Defines the operating system and architecture
-CFLAGS += -DYQ2OSTYPE=\"$(OSTYPE)\" -DYQ2ARCH=\"$(ARCH)\"
+CFLAGS += -DYQ2OSTYPE=\"$(YQ2_OSTYPE)\" -DYQ2ARCH=\"$(YQ2_ARCH)\"
 
 # ----------
 
@@ -191,7 +190,7 @@
 
 # On Windows / MinGW $(CC) is
 # undefined by default.
-ifeq ($(OSTYPE),Windows)
+ifeq ($(YQ2_OSTYPE),Windows)
 CC := gcc
 endif
 
@@ -199,24 +198,16 @@
 
 # Extra CFLAGS for SDL
 ifeq ($(WITH_SDL2),yes)
-ifeq ($(OSTYPE),Windows)
-SDLCFLAGS := $(shell /custom/bin/sdl2-config --cflags)
-else
 SDLCFLAGS := $(shell sdl2-config --cflags)
-endif
 else # not SDL2
-ifeq ($(OSTYPE),Windows)
-SDLCFLAGS :=
-else
 SDLCFLAGS := $(shell sdl-config --cflags)
-endif
 endif # SDL2
 
 # ----------
 
 # Extra CFLAGS for X11
-ifneq ($(OSTYPE), Windows)
-ifneq ($(OSTYPE), Darwin)
+ifneq ($(YQ2_OSTYPE), Windows)
+ifneq ($(YQ2_OSTYPE), Darwin)
 ifeq ($(WITH_X11GAMMA),yes)
 X11CFLAGS := $(shell pkg-config x11 --cflags)
 X11CFLAGS += $(shell pkg-config xxf86vm --cflags)
@@ -227,59 +218,66 @@
 # ----------
 
 # Base include path.
-ifeq ($(OSTYPE),Linux)
+ifeq ($(YQ2_OSTYPE),Linux)
 INCLUDE := -I/usr/include
-else ifeq ($(OSTYPE),FreeBSD)
+else ifeq ($(YQ2_OSTYPE),FreeBSD)
 INCLUDE := -I/usr/local/include
-else ifeq ($(OSTYPE),OpenBSD)
+else ifeq ($(YQ2_OSTYPE),OpenBSD)
 INCLUDE := -I/usr/local/include
-else ifeq ($(OSTYPE),Windows)
-INCLUDE := -I/custom/include
-endif
+else ifeq ($(YQ2_OSTYPE),Windows)
+INCLUDE := -I/usr/include
+endif
+
+# ----------
+
+# Extra includes for GLAD
+GLAD_INCLUDE = -Isrc/client/refresh/gl3/glad/include
 
 # ----------
 
 # Base LDFLAGS.
-ifeq ($(OSTYPE),Linux)
+ifeq ($(YQ2_OSTYPE),Linux)
 LDFLAGS := -L/usr/lib -lm -ldl -rdynamic
-else ifeq ($(OSTYPE),FreeBSD)
+else ifeq ($(YQ2_OSTYPE),FreeBSD)
 LDFLAGS := -L/usr/local/lib -lm
-else ifeq ($(OSTYPE),OpenBSD)
+else ifeq ($(YQ2_OSTYPE),OpenBSD)
 LDFLAGS := -L/usr/local/lib -lm
-else ifeq ($(OSTYPE),Windows)
-LDFLAGS := -L/custom/lib -lws2_32 -lwinmm
-else ifeq ($(OSTYPE), Darwin)
+else ifeq ($(YQ2_OSTYPE),Windows)
+LDFLAGS := -L/usr/lib -lws2_32 -lwinmm -static-libgcc
+else ifeq ($(YQ2_OSTYPE), Darwin)
 LDFLAGS := $(OSX_ARCH) -lm
 endif
 
+CFLAGS += -fvisibility=hidden
+LDFLAGS += -fvisibility=hidden
+
+ifneq ($(YQ2_OSTYPE), Darwin)
+# for some reason the OSX linker doesn't support this
+LDFLAGS += -Wl,--no-undefined
+endif
+
 # ----------
 
 # Extra LDFLAGS for SDL
-ifeq ($(OSTYPE), Windows)
-ifeq ($(WITH_SDL2),yes)
-SDLLDFLAGS := $(shell /custom/bin/sdl2-config --libs)
-else # not SDL2
-SDLLDFLAGS := -lSDL
-endif # SDL2
-else ifeq ($(OSTYPE), Darwin)
-ifeq ($(WITH_SDL2),yes)
-SDLLDFLAGS := -lSDL2 -framework OpenGL -framework Cocoa
+ifeq ($(YQ2_OSTYPE), Darwin)
+ifeq ($(WITH_SDL2),yes)
+SDLLDFLAGS := -lSDL2
 else # not SDL2
 SDLLDFLAGS := -lSDL -framework OpenGL -framework Cocoa
 endif # SDL2
-else # not Darwin/Win
+else # not Darwin
 ifeq ($(WITH_SDL2),yes)
 SDLLDFLAGS := $(shell sdl2-config --libs)
 else # not SDL2
 SDLLDFLAGS := $(shell sdl-config --libs)
 endif # SDL2
-endif # Darwin/Win
+endif # Darwin
 
 # ----------
 
 # Extra LDFLAGS for X11
-ifneq ($(OSTYPE), Windows)
-ifneq ($(OSTYPE), Darwin)
+ifneq ($(YQ2_OSTYPE), Windows)
+ifneq ($(YQ2_OSTYPE), Darwin)
 ifeq ($(WITH_X11GAMMA),yes)
 X11LDFLAGS := $(shell pkg-config x11 --libs)
 X11LDFLAGS += $(shell pkg-config xxf86vm --libs)
@@ -302,12 +300,14 @@
 # ----------
 
 # Phony targets
-.PHONY : all client game icon server
+.PHONY : all client game icon server ref_gl1 ref_gl3
 
 # ----------
 
 # Builds everything
-all: config client server game
+all: config client server game ref_gl1 ref_gl3
+
+# ----------
 
 # Print config values
 config:
@@ -333,7 +333,7 @@
 
 # Special target to compile
 # the icon on Windows
-ifeq ($(OSTYPE), Windows)
+ifeq ($(YQ2_OSTYPE), Windows)
 icon:
 	@echo "===> WR build/icon/icon.res"
 	${Q}mkdir -p build/icon
@@ -345,12 +345,16 @@
 # Cleanup
 clean:
 	@echo "===> CLEAN"
+	${Q}rm -Rf build release/*
+
+cleanall:
+	@echo "===> CLEAN"
 	${Q}rm -Rf build release
 
 # ----------
 
 # The client
-ifeq ($(OSTYPE), Windows)
+ifeq ($(YQ2_OSTYPE), Windows)
 client:
 	@echo "===> Building quake2.exe"
 	${Q}mkdir -p release
@@ -383,8 +387,10 @@
 release/quake2.exe : CFLAGS += -DSDL2
 endif
 
-release/quake2.exe : LDFLAGS += -mwindows -lopengl32
+release/quake2.exe : LDFLAGS += -mwindows
+
 else # not Windows
+
 client:
 	@echo "===> Building quake2"
 	${Q}mkdir -p release
@@ -393,15 +399,17 @@
 build/client/%.o: %.c
 	@echo "===> CC $<"
 	${Q}mkdir -p $(@D)
-	${Q}$(CC) -c $(CFLAGS) $(SDLCFLAGS) $(X11CFLAGS) $(INCLUDE) -o $@ $<
-
-ifeq ($(OSTYPE), Darwin)
+	${Q}$(CC) -c $(CFLAGS) $(SDLCFLAGS) $(INCLUDE) -o $@ $<
+
+ifeq ($(YQ2_OSTYPE), Darwin)
 build/client/%.o : %.m
 	@echo "===> CC $<"
 	${Q}mkdir -p $(@D)
 	${Q}$(CC) $(OSX_ARCH) -x objective-c -c $< -o $@
 endif
 
+release/quake2 : CFLAGS += -Wno-unused-result
+
 ifeq ($(WITH_CDA),yes)
 release/quake2 : CFLAGS += -DCDA
 endif
@@ -413,10 +421,10 @@
 
 ifeq ($(WITH_OPENAL),yes)
 ifeq ($(DLOPEN_OPENAL),yes)
-ifeq ($(OSTYPE), OpenBSD)
+ifeq ($(YQ2_OSTYPE), OpenBSD)
 release/quake2 : CFLAGS += -DUSE_OPENAL -DDEFAULT_OPENAL_DRIVER='"libopenal.so"' -DDLOPEN_OPENAL
-else ifeq ($(OSTYPE), Darwin)
-release/quake2 : CFLAGS += -DUSE_OPENAL -DDEFAULT_OPENAL_DRIVER='"libopenal.dylib"' -I/usr/local/opt/openal-soft/include
+else ifeq ($(YQ2_OSTYPE), Darwin)
+release/quake2 : CFLAGS += -DUSE_OPENAL -DDEFAULT_OPENAL_DRIVER='"libopenal.dylib"' -I/usr/local/opt/openal-soft/include -DDLOPEN_OPENAL
 release/quake2 : LDFLAGS += -L/usr/local/opt/openal-soft/lib
 else
 release/quake2 : CFLAGS += -DUSE_OPENAL -DDEFAULT_OPENAL_DRIVER='"libopenal.so.1"' -DDLOPEN_OPENAL
@@ -424,6 +432,10 @@
 else # !DLOPEN_OPENAL
 release/quake2 : CFLAGS += -DUSE_OPENAL
 release/quake2 : LDFLAGS += -lopenal
+ifeq ($(YQ2_OSTYPE), Darwin)
+release/quake2 : CFLAGS += -I/usr/local/opt/openal-soft/include
+release/quake2 : LDFLAGS += -L/usr/local/opt/openal-soft/lib
+endif # Darwin
 endif # !DLOPEN_OPENAL
 endif # WITH_OPENAL
 
@@ -439,19 +451,9 @@
 ifeq ($(WITH_SDL2),yes)
 release/quake2 : CFLAGS += -DSDL2
 endif
- 
-ifneq ($(OSTYPE), Darwin)
-release/quake2 : LDFLAGS += -lGL
-endif
-
-ifeq ($(OSTYPE), FreeBSD)
-release/quake2 : LDFLAGS += -Wl,-z,origin,-rpath='$$ORIGIN/lib'
-else ifeq ($(OSTYPE), Linux)
-release/quake2 : LDFLAGS += -Wl,-z,origin,-rpath='$$ORIGIN/lib'
-endif
-
-ifeq ($(WITH_SYSTEMWIDE),yes)
-ifneq ($(WITH_SYSTEMDIR),"")
-ifeq ($(OSTYPE), FreeBSD)
-release/quake2 : LDFLAGS += -Wl,-z,origin,-rpath='$(WITH_SYSTEMDIR)/lib'
-else ifeq ($(OSTYPE), Linux)
+
+ifneq ($(YQ2_OSTYPE), Darwin)
+release/ref_gl1.so : LDFLAGS += -lGL
+endif
+
+ifeq ($(YQ2_OSTYPE), FreeBSD)
