=== debian/changelog ===
yquake2 (7.01~dfsg1-1) unstable; urgency=medium

  * New upstream release
    - d/patches: Refresh, drop patches that are no longer needed
  * d/copyright: Use https URL in Format
  * Declare compliance with Policy 4.0.0

 -- Simon McVittie <smcv@debian.org>  Mon, 26 Jun 2017 08:10:51 +0100

yquake2 (7.00~dfsg1-1) unstable; urgency=medium

  * Increase debhelper compat level to 10 for parallel build
  * New upstream release (Closes: #864483)
    - d/copyright: Update
    - d/patches: Refresh
    - d/patches/7.01: Import some post-release fixes from upstream
  * d/control: Fix spelling of "contributors"
  * d/p/Only-use-usr-local-opt-openal-soft-on-Darwin.patch:
    Don't try to link to OpenAL from /usr/local/opt/openal-soft

 -- Simon McVittie <smcv@debian.org>  Sun, 18 Jun 2017 16:08:55 +0100
