=== debian/control ===
--- 
+++ 
@@ -6,7 +6,7 @@
  Fabian Greffrath <fabian@debian.org>,
  Simon McVittie <smcv@debian.org>
 Build-Depends:
- debhelper (>= 9),
+ debhelper (>= 10),
  libgl1-mesa-dev | libgl-dev,
  libopenal-dev,
  libsdl2-dev,
@@ -14,7 +14,7 @@
  libxrandr-dev,
  libxxf86vm-dev,
  zlib1g-dev
-Standards-Version: 3.9.8
+Standards-Version: 4.0.0
 Homepage: http://www.yamagi.org/quake2/
 Vcs-Git: https://anonscm.debian.org/git/pkg-games/yquake2.git
 Vcs-Browser: https://anonscm.debian.org/cgit/pkg-games/yquake2.git
@@ -32,7 +32,7 @@
  Quake II. The main focus is single player, the gameplay and the graphics are
  unchanged, but many bugs were fixed. This code is based upon Icculus Quake II,
  which itself is built upon id Software's original code drop. Additional code
- and patches by many contributers were used.
+ and patches by many contributors were used.
  .
  This engine is intended to be used via the wrapper script and menu entries
  in the quake2 package.
@@ -50,7 +50,7 @@
  This is the Yamagi Quake II Server, an enhanced Version of id Software's
  Quake II. This code is based upon Icculus Quake II,
  which itself is built upon id Software's original code drop. Additional code
- and patches by many contributers were used.
+ and patches by many contributors were used.
  .
  This package contains files common to the client and the server, and a
  dedicated server engine is intended to be used via the wrapper script
